<?php

// Simple InUSE Check
if ( !defined('QF_STARTED') )
        die('Hacking attempt');

define('QF_VIEWARCH_CACHEPREFIX', 'TARS.');
define('QF_TEMPFILE_LIFETIME', 24*3600);

class QF2_file_incls
{
    function _Start()
    {
        global $QF;
        $QF->Run_Module('Files');
    }

    function AJX_Uploader(&$AJAX_STATUS)
    {
        global $QF, $FOX;

        if (!$QF->User->UID || ($QF->User->acc_level < $QF->Config->Get('upl_minlvl', 'files_cfg', 1)))
        {
            $AJAX_STATUS = 403;
            return Lang('FILES_UPL_DISALLOW');
        }

        $error = '';
        if ($file = $QF->GPC->Get_File('upl_file'))
        {
            $real_file = $file['tmp_name'];

            $filename = $file['name'];
            $capt = trim(preg_replace('#(?<=\S)\.\w+$#', '', strtr($filename, '_', ' ')));

            if ($c_recoded = $QF->Session->Get('recode_out'))
                if ($ccapt = $QF->USTR->Str_Convert($capt, QF_INTERNAL_ENCODING, $c_recoded))
                    $capt = $ccapt;
            $data = Array(
                'filename' => $filename, 'caption' => $capt,
                );

            if ($file['error'])
                $error = sprintf($QF->LNG->Lang('ERR_FILES_UPL_SERVER'), $file['name'], $file['error']);
            elseif (!$QF->Files->Create_File($real_file, $data))
                $error = sprintf($QF->LNG->Lang('ERR_FILES_UPL_ERROR'), $file['name']);
        }
        else
            $error = sprintf(Lang('ERR_FILES_UPL_GOTNONE'), '');

        if (!$error)
        {
            $QF->Run_Module('VIS');
            $QF->VIS->Load_Templates();

            $valname = $QF->GPC->Get_String('valname', QF_GPC_POST);
            if (!$valname)
                $valname = 'files';
            $node  = $QF->VIS->Create_Node('FILES_MYTEMPS_AJX');
            $conts = $QF->Files->Get_TempFiles(false, $mime_cls);
            foreach ($conts as $cont_id)
            {
                $cont_item = $QF->Files->Get_FileInfo($cont_id);

                if ($QF->User->acc_level < $cont_item['r_level'])
                    continue;

                $file_info = Array(
                    'FID'      => $cont_item['id'],
                    'CAPTION'  => $cont_item['caption'],
                    'FILENAME' => $cont_item['filename'],
                    'SIZE'     => $cont_item['file_size'],
                    'TYPE'     => $cont_item['mime'],
                    'TIME'     => $QF->LNG->Time_Format($cont_item['time']),
                    'LEVEL'    => $cont_item['r_level'],
                    'DLOADS'   => $cont_item['dloads'],
                    'IS_ARCH'  => ($cont_item['is_arch']) ? 1 : null,
                    'SHOW_THUMB' => ($cont_item['has_pics']) ? 1 : null,
                    'VAL_NAME' => $valname,
                    'SEL_ONE'  => ($sel_one) ? 1 : null,
                    );
                $QF->VIS->Add_Node('FILES_MYTEMPS_ITEM', 'ITEMS', $node, $file_info);
                $i++;
            }

            $data = $QF->VIS->Parse($node);
            $QF->Events->Call_Event_Ref('HTML_block_parse', $data );
            return $data;

        }
        else
        {
            $AJAX_STATUS = 400;
            return $error;
        }

    }

    function Node_MyTemps($valname = 'files', $mime_cls = false, $sel_one = false)
    {
        global $QF, $FOX;

        $QF->VIS->Load_Templates('ajax');

        $node  = $QF->VIS->Create_Node('FILES_MYTEMPS', Array(
            'RET_TO' => base64_encode($QF->HTTP->Request),
            'VALNAME' => $valname) );
        $conts = $QF->Files->Get_TempFiles($QF->User->UID, $mime_cls);

        $QF->Files->Load_FileInfos($conts);
        if (!$valname)
            $valname = 'files';
        foreach ($conts as $cont_id)
        {
            $cont_item = $QF->Files->Get_FileInfo($cont_id);

            if ($cont_item['time'] < ($QF->Timer->time - QF_TEMPFILE_LIFETIME))
            {
                $QF->Files->Drop_File($cont_id);
                continue;
            }

            $file_info = Array(
                'FID'      => $cont_item['id'],
                'CAPTION'  => $cont_item['caption'],
                'FILENAME' => $cont_item['filename'],
                'SIZE'     => $cont_item['file_size'],
                'TYPE'     => $cont_item['mime'],
                'TIME'     => $QF->LNG->Time_Format($cont_item['time']),
                'LEVEL'    => $cont_item['r_level'],
                'DLOADS'   => $cont_item['dloads'],
                'IS_ARCH'  => ($cont_item['is_arch']) ? 1 : null,
                'SHOW_THUMB' => ($cont_item['has_pics']) ? 1 : null,
                'VAL_NAME' => $valname,
                'SEL_ONE'  => ($sel_one) ? 1 : null,
                );
            $QF->VIS->Add_Node('FILES_MYTEMPS_ITEM', 'ITEMS', $node, $file_info);
            $i++;
        }

        return $node;
    }

    function Page_Uploader(&$p_title, &$p_subtitle, &$d_result)
    {
        global $QF, $FOX;

        $ret_to = $QF->GPC->Get_String('return', QF_GPC_GET);
        $back_url = base64_decode($ret_to);
        if (!qf_str_is_url($back_url))
            $ret_to = base64_encode($back_url = QF_INDEX);

        $p_title=$QF->LNG->Lang('FILES_UPLOADER');

        $upl_page = $QF->VIS->Create_Node('FILES_UPLOADER', Array(
            'FILDS_COUNT' => 3,
            'RET_URL' => $back_url,
            'RET_TO' => $ret_to ) );

        return $upl_page;
    }

    function Script_FolderStore()
    {
        global $QF, $FOX;
        $to_folder = $QF->GPC->Get_Num('to_folder', QF_GPC_POST);
        if (!($fold_info = $QF->Files->Get_FolderInfo($to_folder)))
            $QF->HTTP->Redirect($FOX->Gen_URL('fox2_files_viewrootdir'));

        $move_files = $QF->GPC->Get_Raw('files', QF_GPC_POST);

        if ($fold_info['w_level'] > $QF->User->acc_level && $QF->User->adm_level == 0)
            return Array(Lang('ERR_FOLDER_NOACCESS'), $FOX->Gen_URL('fox2_files_openfolder', $to_folder), true);


        $QF->Files->Load_FileInfos($move_files);
        if (is_array($move_files))
        foreach ($move_files as $fid)
        {
            $finfo = $QF->Files->Get_FileInfo($fid);
            if (($finfo['author_id'] != $QF->User->UID) && $QF->User->adm_level == 0)
                return Array(sprintf(Lang('ERR_FILES_NOTOWNER'), $finfo['caption']), $FOX->Gen_URL('fox2_files_openfolder', $to_folder));

            $QF->Files->Move_File($fid, $to_folder);
        }
        if ($file = $QF->GPC->Get_File('upl_file'))
        {
            $real_file = $file['tmp_name'];
            $filename = $file['name'];
            $capt = trim(preg_replace('#(?<=\S)\.\w+$#', '', strtr($filename, '_', ' ')));

            if ($c_recoded = $QF->Session->Get('recode_out'))
                if ($ccapt = $QF->USTR->Str_Convert($capt, QF_INTERNAL_ENCODING, $c_recoded))
                    $capt = $ccapt;
            $data = Array(
                'filename' => $filename, 'caption' => $capt,
                );

            if ($file['error'])
                return Array(sprintf($QF->LNG->Lang('ERR_FILES_UPL_SERVER'), $file['name'], $file['error']), $FOX->Gen_URL('fox2_files_openfolder', $to_folder));
            elseif (!($fid = $QF->Files->Create_File($real_file, $data)))
                return Array(sprintf($QF->LNG->Lang('ERR_FILES_UPL_ERROR'), $file['name']), $FOX->Gen_URL('fox2_files_openfolder', $to_folder));

            $QF->Files->Move_File($fid, $to_folder);
        }

        return Array(sprintf(Lang('RES_FILES_STORED_OK'), $fold_info['name']), $FOX->Gen_URL('fox2_files_openfolder', $to_folder));
    }

    function Script_Uploader()
    {
        global $QF, $FOX;

        $errors = Array();
        $got_files = 0;

        $ret_to = $QF->GPC->Get_String('return', QF_GPC_POST);
        $back_url = base64_decode($ret_to);
        if (!qf_str_is_url($back_url))
            $ret_to = base64_encode($back_url = QF_INDEX);

        if (!$QF->User->UID || ($QF->User->acc_level < $QF->Config->Get('upl_minlvl', 'files_cfg', 1)))
            return Array(Lang('FILES_UPL_DISALLOW'), $back_url, true);

        if ($files = $QF->GPC->Get_File('upl_file'))
        {
            $capts = $QF->GPC->Get_Raw('upl_descr', QF_GPC_POST);
            foreach($files as $file_id)
                if ($file = $QF->GPC->Get_File($file_id))
                {
                    $real_file = $file['tmp_name'];
                    $filename = preg_replace('#[^\w\.\-]#', '_', $file['name']);
                    $capt = trim(preg_replace('#(?<=\S)\.\w+$#', '', strtr($filename, '_', ' ')));

                    if (preg_match('#upl_file\[(.+)\]#', $file_id, $mts) && isset($capts[$mts[1]]) && $capts[$mts[1]])
                        $capt = $capts[$mts[1]];
                    if ($c_recoded = $QF->Session->Get('recode_out'))
                        if ($ccapt = $QF->USTR->Str_Convert($capt, QF_INTERNAL_ENCODING, $c_recoded))
                            $capt = $ccapt;
                    $data = Array(
                        'filename' => $filename, 'caption' => $capt,
                        );


                    if ($file['error'])
                        $errors[] = sprintf($QF->LNG->Lang('ERR_FILES_UPL_SERVER'), $file['name'], $file['error']);
                    elseif (!$QF->Files->Create_File($real_file, $data))
                        $errors[] = sprintf($QF->LNG->Lang('ERR_FILES_UPL_ERROR'), $file['name']);
                    else
                        $got_files++;
                }
        }

        $errors = '<br />'.implode('<br />', $errors);
        if (!$got_files)
            return Array(sprintf(Lang('ERR_FILES_UPL_GOTNONE'), $errors), $FOX->Gen_URL('fox2_file_uploader', $ret_to), true);
        else
            return Array(sprintf(Lang('RES_FILES_UPL_GOTOK'), $errors), $back_url);
    }

    function Page_ViewFolder(&$p_title, &$p_subtitle, &$d_result)
    {
        global $QF, $FOX;

        $fold_id = $QF->GPC->Get_Num('id', QF_GPC_GET);
        if (!$fold_id)
            $fold_id = 0;
        if ($info = $QF->Files->Get_FolderInfo($fold_id))
        {
            $conts = $QF->Files->Get_FolderConts($fold_id);
            $finfo_page = $QF->VIS->Create_Node('FILES_FOLDER_PAGE');
            $PageInfo = Array(
                    'FID'      => $info['id'],
                    'CAPTION'  => $info['name'],
                    'TIME'     => $QF->LNG->Time_Format($info['time']),
                );

            if ($info['w_level'] <= $QF->User->acc_level || $QF->User->adm_level > 0)
                $PageInfo['PERM_STORE'] = 1;

            $QF->VIS->Add_Data_Array($finfo_page, $PageInfo);
            $p_title = $info['name'];

            $pages = (int) ceil(count($conts)/20);
            $page = $QF->GPC->Get_Num('page', QF_GPC_GET);
            if ($page < 1)
                $page = 1;
            elseif ($page > $pages)
                $page = $pages;

            if ($pages>1)
            {
                $draw_pages = Array();
                $pp=False;
                for($stt=1; $stt<=$pages; $stt++)
                {
                    if ($stt <= 4 || $stt >= ($pages - 3) || Abs($stt - $page) < 3) {
                        $draw_pages[] = Array('FOLD_ID' => $fold_id, 'PAGE' => $stt, 'CUR' => ($stt == $page) ? true : null);
                        $pp = true;
                    }
                    elseif ($pp)
                    {
                        $draw_pages[] = Array('SEPAR' => true);
                        $pp = false;
                    }
                }
                $QF->VIS->Add_Node_Array('FILES_FOLDER_PAGE_BTN', 'PAGE_BTNS', $finfo_page, $draw_pages);
                $QF->VIS->Add_Data($finfo_page, 'CUR_PAGE', $page);

                $start = 20*($page - 1);
                $conts = array_slice($conts, $start, 20);
            }

            $QF->Files->Load_FileInfos($conts);
            $i = 0;
            foreach ($conts as $cont_id)
            {
                $cont_item = $QF->Files->Get_FileInfo($cont_id);

                if ($QF->User->acc_level < $cont_item['r_level'])
                    continue;

                if (($i % 4) == 0)
                    $row = $QF->VIS->Add_Node('FILES_FOLDER_ROW', 'ROWS', $finfo_page);
                $file_info = Array(
                    'FID'      => $cont_item['id'],
                    'CAPTION'  => $cont_item['caption'],
                    'FILENAME' => $cont_item['filename'],
                    'SIZE'     => $cont_item['file_size'],
                    'TYPE'     => $cont_item['mime'],
                    'TIME'     => $QF->LNG->Time_Format($cont_item['time']),
                    'LEVEL'    => $cont_item['r_level'],
                    'DLOADS'   => $cont_item['dloads'],
                    'IS_ARCH'  => ($cont_item['is_arch']) ? 1 : null,
                    'SHOW_THUMB' => ($cont_item['has_pics']) ? 1 : null,
                    );
                $QF->VIS->Add_Node('FILES_FOLDER_ITEM', 'ITEMS', $row, $file_info);
                $i++;
            }

            $temps = $this->Node_MyTemps('files');
            $QF->VIS->Append_Node($temps, 'MYTEMPS', $finfo_page);

            return $finfo_page;
        }
        else
            $QF->HTTP->Redirect($FOX->Gen_URL('fox2_files_viewrootdir'));

    }

    function DPage_GetFile()
    {
        global $QF, $FOX;

        $file_id = $QF->GPC->Get_String('fid', QF_GPC_GET, QF_STR_HEX);
        $dcode = $QF->GPC->Get_String('dcode', QF_GPC_GET, QF_STR_HEX);

        if (($info = $QF->Files->Get_FileInfo($file_id)) && $info['file_link'])
        {
            if ($QF->Files->Check_DCode($file_id, $dcode))
            {
                $flags = 0;
                if ($QF->Config->Get('tricky_gecko', 'files_cfg') && preg_match('#\WGecko\/#i', $QF->HTTP->UAgent))
                    $flags |= QF_HTTP_FILE_RFC1522;
                elseif ($QF->Config->Get('tricky_opera', 'files_cfg') && preg_match('#^Opera\/|\WGecko\/|Download\x20Master#i', $QF->HTTP->UAgent))
                    $flags |= QF_HTTP_FILE_TRICKY;
                if (!$QF->Config->Get('send_inline', 'files_cfg'))
                    $flags |= QF_HTTP_FILE_ATTACHMENT;

                $QF->HTTP->Send_File($info['file_link'], $info['filename'], $info['mime'], $info['time'], $flags);
            }
            elseif ($dcode = $QF->Files->Gen_DCode($file_id)) // new DCode genereted
            {
                $QF->HTTP->Redirect($FOX->Gen_URL('fox2_file_download_dcode', Array($info['id'], $dcode)));
            }
            else
                $FOX->Set_Result(Lang('ERR_FILE_NOACCESS'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);

        }
        else
            $FOX->Set_Result(Lang('ERR_FILE_NOT_FOUND'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);
    }

    function DPage_FilePreview()
    {
        global $QF, $FOX;

        $file_id = $QF->GPC->Get_String('fid', QF_GPC_GET, QF_STR_HEX);

        if (($info = $QF->Files->Get_FileInfo($file_id)) && $info['prv_link'])
        {
            $QF->Session->Open_Session();

            if (!$QF->User->is_spider && ($QF->User->acc_level >= $info['r_level']))
            {
                if ($QF->Config->Get('tricky_gecko', 'files_cfg') && preg_match('#\WGecko\/#i', $QF->HTTP->UAgent))
                    $flags |= QF_HTTP_FILE_RFC1522;
                elseif ($QF->Config->Get('tricky_opera', 'files_cfg') && preg_match('#^Opera\/|\WGecko\/|Download\x20Master#i', $QF->HTTP->UAgent))
                    $flags |= QF_HTTP_FILE_TRICKY;

                $QF->HTTP->Send_File($info['prv_link'], 'prv_'.$info['filename'], $info['pics_mime'], $info['time'], $flags);
            }
            else
                $QF->HTTP->Redirect('images/att_low.gif');
        }
        else
            $QF->HTTP->Redirect('images/att_ferr.gif');

    }

    function DPage_FileThumb()
    {
        global $QF, $FOX;

        $file_id = $QF->GPC->Get_String('fid', QF_GPC_GET, QF_STR_HEX);

        if (($info = $QF->Files->Get_FileInfo($file_id)) && $info['thb_link'])
        {
            $QF->Session->Open_Session();

            if (!$QF->User->is_spider && ($QF->User->acc_level >= $info['r_level']))
            {
                if ($QF->Config->Get('tricky_gecko', 'files_cfg') && preg_match('#\WGecko\/#i', $QF->HTTP->UAgent))
                    $flags |= QF_HTTP_FILE_RFC1522;
                elseif ($QF->Config->Get('tricky_opera', 'files_cfg') && preg_match('#^Opera\/|\WGecko\/|Download\x20Master#i', $QF->HTTP->UAgent))
                    $flags |= QF_HTTP_FILE_TRICKY;

                $QF->HTTP->Send_File($info['thb_link'], 'thb_'.$info['filename'], $info['pics_mime'], $info['time'], $flags);
            }
            else
                $QF->HTTP->Redirect('images/att_low.gif');
        }
        else
            $QF->HTTP->Redirect('images/att_ferr.gif');

    }

    function DPage_GetArchFile()
    {
        global $QF, $FOX;

        $file_id = $QF->GPC->Get_String('fid', QF_GPC_GET, QF_STR_HEX);
        $id = $QF->GPC->Get_Num('part', QF_GPC_GET);
        $dcode = $QF->GPC->Get_String('dcode', QF_GPC_GET, QF_STR_HEX);

        if (($info = $QF->Files->Get_FileInfo($file_id)) && ($info['file_link']))
        {
            $QF->Run_Module('TARFS');
            $cachename = QF_VIEWARCH_CACHEPREFIX.$file_id;
            $tarfile = null;
            if ($contents = $QF->Cache->Get($cachename))
            {
                // do nothing - contents is needed later
            }
            elseif (($tarfile = $QF->TARFS->OpenTAR($info['file_link'])) && ($contents = $QF->TARFS->ParseContent($tarfile)))
            {
                $QF->Cache->Set($cachename, $contents);
            }

            if ($contents)
            {
                if (!isset($contents[$id]) || $contents[$id]['type']!=0)
                    $QF->HTTP->Redirect($FOX->Gen_URL('fox2_file_viewarch', Array($file_id)));

                if ($QF->Files->Check_DCode($file_id, $dcode))
                {
                    $temp_id = $cachename.'.'.$id;
                    if (!($filename = $QF->Cache->Get_TempFile($temp_id)))
                    {
                        $filename = $QF->Cache->Create_TempFile($temp_id);
                        if (!$tarfile)
                            $tarfile = $QF->TARFS->OpenTAR($info['file_link']);
                        if ($QF->TARFS->UnpackFile($tarfile, $id, $filename, true, '600'))
                            touch($filename);
                        else
                        {
                            unlink($filename);
                            $filename = null;
                        }
                    }

                    if (!$filename)
                        trigger_error('FOX_GETARCH: Can\'t extract file '.$id.' from '.$file_id, E_USER_ERROR);

                    $subinfo = $contents[$id];
                    $ftype = pathinfo($subinfo['name']);
                    $ftype = $QF->DSets->Get_DSet_Value('mimetypes', strtolower($ftype['extension']));

                    $flags = 0;
                    if ($QF->Config->Get('tricky_gecko', 'files_cfg') && preg_match('#\WGecko\/#i', $QF->HTTP->UAgent))
                        $flags |= QF_HTTP_FILE_RFC1522;
                    elseif ($QF->Config->Get('tricky_opera', 'files_cfg') && preg_match('#^Opera\/|\WGecko\/|Download\x20Master#i', $QF->HTTP->UAgent))
                        $flags |= QF_HTTP_FILE_TRICKY;
                    if (!$QF->Config->Get('send_inline', 'files_cfg'))
                        $flags |= QF_HTTP_FILE_ATTACHMENT;

                    $QF->HTTP->Send_File($filename, $subinfo['name'], $ftype['mime'], $subinfo['time'], $flags);
                }
                elseif ($dcode = $QF->Files->Gen_DCode($file_id)) // new DCode genereted
                {
                    $QF->HTTP->Redirect($FOX->Gen_URL('fox2_viewarch_download_dcode', Array($info['id'], $id, $dcode)));
                }
                else
                    $FOX->Set_Result(Lang('ERR_FILE_NOACCESS'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);
            }
            else
                $FOX->Set_Result(Lang('ERR_FILE_NOTARCH'), $FOX->Gen_URL('fox2_file_fileinfo', Array($file_id)), true);
        }
        else
            $FOX->Set_Result(Lang('ERR_FILE_NOT_FOUND'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);
    }

    function Page_ViewArch(&$p_title, &$p_subtitle, &$d_result)
    {
        global $QF, $FOX;

        $file_id = $QF->GPC->Get_String('fid', QF_GPC_GET, QF_STR_HEX);
        if (!$file_id)
        {
            $QF->HTTP->Redirect($FOX->Gen_URL('fox2_files_viewrootdir'));
        }
        elseif (!($info = $QF->Files->Get_FileInfo($file_id)))
        {
            $d_result = Array(Lang('ERR_FILE_NOT_FOUND'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);
        }
        elseif ($QF->User->is_spider || !($QF->User->acc_level >= $info['r_level']))
        {
            $d_result = Array(Lang('ERR_FILE_NOACCESS'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);
        }
        elseif ($info['file_link'])
        {
            $QF->Run_Module('TARFS');
            $cachename = QF_VIEWARCH_CACHEPREFIX.$file_id;
            if ($contents = $QF->Cache->Get($cachename))
            {
                // do nothing - contents is ready
            }
            elseif (($tarfile = $QF->TARFS->OpenTAR($info['file_link'])) && ($contents = $QF->TARFS->ParseContent($tarfile)))
            {
                $QF->Cache->Set($cachename, $contents);
                $QF->TARFS->CloseTAR($tarfile);
                unset($tarfile);
            }


            if ($contents) // if we got contents
            {
                $file_id = $info['id'];
                $finfo_page = $QF->VIS->Create_Node('FILES_VIEWARCH');
                $PageInfo = Array(
                        'FID'      => $info['id'],
                        'CAPTION'  => $info['caption'],
                        'FILENAME' => $info['filename'],
                    );
                $QF->VIS->Add_Data_Array($finfo_page, $PageInfo);

                $pages = (int) ceil(count($contents)/20);
                $page = $QF->GPC->Get_Num('page', QF_GPC_GET);
                if ($page < 1)
                    $page = 1;
                elseif ($page > $pages)
                    $page = $pages;

                if ($pages>1)
                {
                    $draw_pages = Array();
                    $pp=False;
                    for($stt=1; $stt<=$pages; $stt++)
                    {
                        if ($stt <= 4 || $stt >= ($pages - 3) || Abs($stt - $page) < 3) {
                            $draw_pages[] = Array('FILE_ID' => $file_id, 'PAGE' => $stt, 'CUR' => ($stt == $page) ? true : null);
                            $pp = true;
                        }
                        elseif ($pp)
                        {
                            $draw_pages[] = Array('SEPAR' => true);
                            $pp = false;
                        }
                    }
                    $QF->VIS->Add_Node_Array('FILES_VIEWARCH_PAGE_BTN', 'PAGE_BTNS', $finfo_page, $draw_pages);
                    $QF->VIS->Add_Data($finfo_page, 'CUR_PAGE', $page);
                }

                $cont_list = Array();
                $start = 20*($page - 1) + 1;
                $stop = min($start + 20, count($contents));
                for ($id = $start; $id < $stop; $id++)
                {
                    $subinfo = $contents[$id];
                    $cont_list[] = Array(
                        'ARCHID'   => $file_id,
                        'ID'       => $id,
                        'FILENAME' => $subinfo['name'],
                        'FILESIZE' => $subinfo['size'],
                        'FILETIME' => $QF->LNG->Time_Format($subinfo['time']),
                        'NOT_FILE' => ($subinfo['type'] != 0) ? true : null,
                        );
                }
                $QF->VIS->Add_Node_Array('FILES_VIEWARCH_CONT_ROW', 'CONT_LIST', $finfo_page, $cont_list);

                $p_title = sprintf($QF->LNG->lang('FILES_VIEWARCH_PAGE_CAPT'), $info['filename']);

                return $finfo_page;
            }
            else
                $d_result = Array(Lang('ERR_FILE_NOTARCH'), $FOX->Gen_URL('fox2_file_fileinfo', Array($file_id)), true);

        }
        else
            $d_result = Array(Lang('ERR_FILE_NOT_FOUND'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);

        return false;
    }

    function Page_FileInfo(&$p_title, &$p_subtitle, &$d_result)
    {
        global $QF, $FOX;

        $file_id = $QF->GPC->Get_String('fid', QF_GPC_GET, QF_STR_HEX);
        if (!$file_id)
        {
            $QF->HTTP->Redirect($FOX->Gen_URL('fox2_files_viewrootdir'));
        }
        elseif ($info = $QF->Files->Get_FileInfo($file_id))
        {
            $QF->Run_Module('UList');
            $finfo_page = $QF->VIS->Create_Node('FILES_INFOPAGE');
            if ($QF->User->adm_level && $QF->GPC->Get_String('force_regen', QF_GPC_GET, QF_STR_HEX)
                && strstr($info['mime'], 'image/') && $QF->Files->Regen_Pics($file_id))
                $info = $QF->Files->Get_FileInfo($file_id);

            $PageInfo = Array(
                    'FID'      => $info['id'],
                    'CAPTION'  => $info['caption'],
                    'FILENAME' => $info['filename'],
                    'SIZE'     => $info['file_size'],
                    'TYPE'     => $info['mime'],
                    'TIME'     => $QF->LNG->Time_Format($info['time']),
                    'LEVEL'    => $info['r_level'],
                    'DLOADS'   => $info['dloads'],
                    'IS_ARCH'  => ($info['is_arch']) ? 1 : null,
                    'SHOW_PREVIEW' => ($info['has_pics'] && $info['prv_link']) ? 1 : null,
                );

            if (!$QF->User->is_spider && ($QF->User->acc_level >= $info['r_level']))
                $PageInfo['GOT_ACCESS'] = '1';

            if ($uinfo = $QF->UList->Get_UserInfo($info['author_id']))
                $QF->VIS->Add_Node('USER_INFO_MIN', 'AUTHOR', $finfo_page, $uinfo);
            elseif ($info['author'])
                $PageInfo['AUTHOR'] = $info['author'];
            else
                $PageInfo['AUTHOR'] = Lang('NO_DATA');

            if ($QF->User->UID && $QF->User->adm_level)
            {
                $PageInfo['SHOW_ADM'] = 'true';
                if ($info['author_ip'])
                    $PageInfo['AUTHOR_IP'] = IP_from_int($info['author_ip']);
            }

            $QF->VIS->Add_Data_Array($finfo_page, $PageInfo);
            $p_title = $QF->LNG->lang('FILE_INFOPAGE_CAPT');
            $p_title = $info['caption'];
            return $finfo_page;
        }
        else
            $d_result = Array(Lang('ERR_FILE_NOT_FOUND'), $FOX->Gen_URL('fox2_files_viewrootdir'), true);

        return false;
    }
}

?>